from AutoRPE.UtilsRPE.Classes import Current_block
from AutoRPE.UtilsRPE.Functions import in_which_block, type_of_contents
import AutoRPE.UtilsRPE.RegexPattern as RegexPattern
import AutoRPE.UtilsRPE.VariablePrecision as VariablePrecision
import re


def fix_pointer_assignations(implement_rpe_file):
    current_block = Current_block(implement_rpe_file.module.main())

    for line_index, line in enumerate(implement_rpe_file.lines):
        pointer_assignation = re.search(RegexPattern.pointers_assignation, line)
        if not pointer_assignation:
            current_block = in_which_block(line, current_block, vault=implement_rpe_file.source_info)
        else:

            # Group 1 contains eventual pointer attributes
            pointer = pointer_assignation.group(2).strip()
            target = pointer_assignation.group(3).strip()
            pointer_type = type_of_contents(pointer, routine=current_block.routine, vault=implement_rpe_file.source_info)
            target_type = type_of_contents(target, routine=current_block.routine, vault=implement_rpe_file.source_info)
            if pointer_type in VariablePrecision.real_types and target_type == "rpe_var":
                implement_rpe_file.lines[line_index] = line.replace(target, "%s%%val" % target)


def get_pointer_target(line, routine, vault):
    # Ignore the if condition. This is not an ideal solution, but the easier for the moment
    line = remove_if_condition(line)
    if line.count("::"):
        line = line.split("::")[1]
    pointers = line.strip().split("=>")
    try:
        ptr = retrieve_variable(pointers[0].strip(), routine=routine, vault=vault)
    except Error.VariableNotFound:
        # Is a pointer to routine
        if vault.get_procedure_by_name(pointers[1].strip(), module_name=routine.module.name):
            return [None, None]
        else:
            raise Error.VariableNotFound
    if pointers[1].lower().replace(" ", "") == "null()":
        return [None, None]
    else:
        # Is a pointer to procedure
        if ptr.type == 'procedure':
            try:
                from AutoRPE.UtilsRPE.Classes import Function
                target = vault.get_procedure_by_name(pointers[1].strip(), procedure_type=Function, module_name=routine.module.name)
                # It is a pointer to function, i.e. a variable is associated with it
                return ptr, target
            except Error.ProcedureNotFound:
                # It is a pointer to subr
                return [None, None]
        else:
            target = retrieve_variable(pointers[1].strip(), routine=routine, vault=vault)
    return ptr, target


def is_pointer_assignment(string):
    pattern = ".* => .*"
    mask = literal_mask(string)
    match = re.search(pattern, string, flags=re.I)
    if match and not mask[string.index("=>")]:
        return True
    return False
